/**
 * Catapult REST Endpoints
 * OpenAPI Specification of catapult-rest
 *
 * The version of the OpenAPI document: 1.0.3
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import * as runtime from '../runtime';
import { AccountIds, AccountInfoDTO, AccountOrderByEnum, AccountPage, MerkleStateInfoDTO, Order } from '../models';
export interface GetAccountInfoRequest {
    accountId: string;
}
export interface GetAccountInfoMerkleRequest {
    accountId: string;
}
export interface GetAccountsInfoRequest {
    accountIds?: AccountIds;
}
export interface SearchAccountsRequest {
    pageSize?: number;
    pageNumber?: number;
    offset?: string;
    order?: Order;
    orderBy?: AccountOrderByEnum;
    mosaicId?: string;
}
/**
 *
 */
export declare class AccountRoutesApi extends runtime.BaseAPI {
    /**
     * Returns the account information.
     * Get account information
     */
    getAccountInfoRaw(requestParameters: GetAccountInfoRequest): Promise<runtime.ApiResponse<AccountInfoDTO>>;
    /**
     * Returns the account information.
     * Get account information
     */
    getAccountInfo(accountId: string): Promise<AccountInfoDTO>;
    /**
     * Returns the account merkle information.
     * Get account merkle information
     */
    getAccountInfoMerkleRaw(requestParameters: GetAccountInfoMerkleRequest): Promise<runtime.ApiResponse<MerkleStateInfoDTO>>;
    /**
     * Returns the account merkle information.
     * Get account merkle information
     */
    getAccountInfoMerkle(accountId: string): Promise<MerkleStateInfoDTO>;
    /**
     * Returns the account information for an array of accounts.
     * Get accounts information
     */
    getAccountsInfoRaw(requestParameters: GetAccountsInfoRequest): Promise<runtime.ApiResponse<Array<AccountInfoDTO>>>;
    /**
     * Returns the account information for an array of accounts.
     * Get accounts information
     */
    getAccountsInfo(accountIds?: AccountIds): Promise<Array<AccountInfoDTO>>;
    /**
     * Gets an array of accounts.
     * Search accounts
     */
    searchAccountsRaw(requestParameters: SearchAccountsRequest): Promise<runtime.ApiResponse<AccountPage>>;
    /**
     * Gets an array of accounts.
     * Search accounts
     */
    searchAccounts(pageSize?: number, pageNumber?: number, offset?: string, order?: Order, orderBy?: AccountOrderByEnum, mosaicId?: string): Promise<AccountPage>;
}
