/**
 * Catapult REST Endpoints
 * OpenAPI Specification of catapult-rest
 *
 * The version of the OpenAPI document: 1.0.3
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import * as runtime from '../runtime';
import { HashLockInfoDTO, HashLockPage, MerkleStateInfoDTO, Order } from '../models';
export interface GetHashLockRequest {
    hash: string;
}
export interface GetHashLockMerkleRequest {
    hash: string;
}
export interface SearchHashLockRequest {
    address?: string;
    pageSize?: number;
    pageNumber?: number;
    offset?: string;
    order?: Order;
}
/**
 *
 */
export declare class HashLockRoutesApi extends runtime.BaseAPI {
    /**
     * Gets the hash lock for a given hash.
     * Get hash lock information
     */
    getHashLockRaw(requestParameters: GetHashLockRequest): Promise<runtime.ApiResponse<HashLockInfoDTO>>;
    /**
     * Gets the hash lock for a given hash.
     * Get hash lock information
     */
    getHashLock(hash: string): Promise<HashLockInfoDTO>;
    /**
     * Gets the hash lock merkle for a given hash.
     * Get hash lock merkle information
     */
    getHashLockMerkleRaw(requestParameters: GetHashLockMerkleRequest): Promise<runtime.ApiResponse<MerkleStateInfoDTO>>;
    /**
     * Gets the hash lock merkle for a given hash.
     * Get hash lock merkle information
     */
    getHashLockMerkle(hash: string): Promise<MerkleStateInfoDTO>;
    /**
     * Returns an array of hash locks.
     * Search hash lock entries
     */
    searchHashLockRaw(requestParameters: SearchHashLockRequest): Promise<runtime.ApiResponse<HashLockPage>>;
    /**
     * Returns an array of hash locks.
     * Search hash lock entries
     */
    searchHashLock(address?: string, pageSize?: number, pageNumber?: number, offset?: string, order?: Order): Promise<HashLockPage>;
}
