/**
 * Catapult REST Endpoints
 * OpenAPI Specification of catapult-rest
 *
 * The version of the OpenAPI document: 1.0.3
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import * as runtime from '../runtime';
import { MerkleStateInfoDTO, MetadataInfoDTO, MetadataPage, MetadataTypeEnum, Order } from '../models';
export interface GetMetadataRequest {
    compositeHash: string;
}
export interface GetMetadataMerkleRequest {
    compositeHash: string;
}
export interface SearchMetadataEntriesRequest {
    sourceAddress?: string;
    targetAddress?: string;
    scopedMetadataKey?: string;
    targetId?: string;
    metadataType?: MetadataTypeEnum;
    pageSize?: number;
    pageNumber?: number;
    offset?: string;
    order?: Order;
}
/**
 *
 */
export declare class MetadataRoutesApi extends runtime.BaseAPI {
    /**
     * Gets the metadata for a given composite hash.
     * Get metadata information
     */
    getMetadataRaw(requestParameters: GetMetadataRequest): Promise<runtime.ApiResponse<MetadataInfoDTO>>;
    /**
     * Gets the metadata for a given composite hash.
     * Get metadata information
     */
    getMetadata(compositeHash: string): Promise<MetadataInfoDTO>;
    /**
     * Gets the metadata merkle for a given composite hash.
     * Get metadata merkle information
     */
    getMetadataMerkleRaw(requestParameters: GetMetadataMerkleRequest): Promise<runtime.ApiResponse<MerkleStateInfoDTO>>;
    /**
     * Gets the metadata merkle for a given composite hash.
     * Get metadata merkle information
     */
    getMetadataMerkle(compositeHash: string): Promise<MerkleStateInfoDTO>;
    /**
     * Returns an array of metadata.
     * Search metadata entries
     */
    searchMetadataEntriesRaw(requestParameters: SearchMetadataEntriesRequest): Promise<runtime.ApiResponse<MetadataPage>>;
    /**
     * Returns an array of metadata.
     * Search metadata entries
     */
    searchMetadataEntries(sourceAddress?: string, targetAddress?: string, scopedMetadataKey?: string, targetId?: string, metadataType?: MetadataTypeEnum, pageSize?: number, pageNumber?: number, offset?: string, order?: Order): Promise<MetadataPage>;
}
