/**
 * Catapult REST Endpoints
 * OpenAPI Specification of catapult-rest
 *
 * The version of the OpenAPI document: 1.0.3
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import * as runtime from '../runtime';
import { MerkleStateInfoDTO, MosaicIds, MosaicInfoDTO, MosaicPage, Order } from '../models';
export interface GetMosaicRequest {
    mosaicId: string;
}
export interface GetMosaicMerkleRequest {
    mosaicId: string;
}
export interface GetMosaicsRequest {
    mosaicIds: MosaicIds;
}
export interface SearchMosaicsRequest {
    ownerAddress?: string;
    pageSize?: number;
    pageNumber?: number;
    offset?: string;
    order?: Order;
}
/**
 *
 */
export declare class MosaicRoutesApi extends runtime.BaseAPI {
    /**
     * Gets the mosaic definition for a given mosaic identifier.
     * Get mosaic information
     */
    getMosaicRaw(requestParameters: GetMosaicRequest): Promise<runtime.ApiResponse<MosaicInfoDTO>>;
    /**
     * Gets the mosaic definition for a given mosaic identifier.
     * Get mosaic information
     */
    getMosaic(mosaicId: string): Promise<MosaicInfoDTO>;
    /**
     * Gets the mosaic definition merkle for a given mosaic identifier.
     * Get mosaic merkle information
     */
    getMosaicMerkleRaw(requestParameters: GetMosaicMerkleRequest): Promise<runtime.ApiResponse<MerkleStateInfoDTO>>;
    /**
     * Gets the mosaic definition merkle for a given mosaic identifier.
     * Get mosaic merkle information
     */
    getMosaicMerkle(mosaicId: string): Promise<MerkleStateInfoDTO>;
    /**
     * Gets an array of mosaic definition.
     * Get mosaics information for an array of mosaics
     */
    getMosaicsRaw(requestParameters: GetMosaicsRequest): Promise<runtime.ApiResponse<Array<MosaicInfoDTO>>>;
    /**
     * Gets an array of mosaic definition.
     * Get mosaics information for an array of mosaics
     */
    getMosaics(mosaicIds: MosaicIds): Promise<Array<MosaicInfoDTO>>;
    /**
     * Gets an array of mosaics.
     * Search mosaics
     */
    searchMosaicsRaw(requestParameters: SearchMosaicsRequest): Promise<runtime.ApiResponse<MosaicPage>>;
    /**
     * Gets an array of mosaics.
     * Search mosaics
     */
    searchMosaics(ownerAddress?: string, pageSize?: number, pageNumber?: number, offset?: string, order?: Order): Promise<MosaicPage>;
}
