/**
 * Catapult REST Endpoints
 * OpenAPI Specification of catapult-rest
 *
 * The version of the OpenAPI document: 1.0.3
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import * as runtime from '../runtime';
import { AccountsNamesDTO, Addresses, AliasTypeEnum, MerkleStateInfoDTO, MosaicIds, MosaicsNamesDTO, NamespaceIds, NamespaceInfoDTO, NamespaceNameDTO, NamespacePage, NamespaceRegistrationTypeEnum, Order } from '../models';
export interface GetAccountsNamesRequest {
    addresses: Addresses;
}
export interface GetMosaicsNamesRequest {
    mosaicIds: MosaicIds;
}
export interface GetNamespaceRequest {
    namespaceId: string;
}
export interface GetNamespaceMerkleRequest {
    namespaceId: string;
}
export interface GetNamespacesNamesRequest {
    namespaceIds: NamespaceIds;
}
export interface SearchNamespacesRequest {
    ownerAddress?: string;
    registrationType?: NamespaceRegistrationTypeEnum;
    level0?: string;
    aliasType?: AliasTypeEnum;
    pageSize?: number;
    pageNumber?: number;
    offset?: string;
    order?: Order;
}
/**
 *
 */
export declare class NamespaceRoutesApi extends runtime.BaseAPI {
    /**
     * Returns friendly names for accounts.
     * Get readable names for a set of accountIds
     */
    getAccountsNamesRaw(requestParameters: GetAccountsNamesRequest): Promise<runtime.ApiResponse<AccountsNamesDTO>>;
    /**
     * Returns friendly names for accounts.
     * Get readable names for a set of accountIds
     */
    getAccountsNames(addresses: Addresses): Promise<AccountsNamesDTO>;
    /**
     * Returns friendly names for mosaics.
     * Get readable names for a set of mosaics
     */
    getMosaicsNamesRaw(requestParameters: GetMosaicsNamesRequest): Promise<runtime.ApiResponse<MosaicsNamesDTO>>;
    /**
     * Returns friendly names for mosaics.
     * Get readable names for a set of mosaics
     */
    getMosaicsNames(mosaicIds: MosaicIds): Promise<MosaicsNamesDTO>;
    /**
     * Gets the namespace for a given namespace identifier.
     * Get namespace information
     */
    getNamespaceRaw(requestParameters: GetNamespaceRequest): Promise<runtime.ApiResponse<NamespaceInfoDTO>>;
    /**
     * Gets the namespace for a given namespace identifier.
     * Get namespace information
     */
    getNamespace(namespaceId: string): Promise<NamespaceInfoDTO>;
    /**
     * Gets the namespace merkle for a given namespace identifier.
     * Get namespace merkle information
     */
    getNamespaceMerkleRaw(requestParameters: GetNamespaceMerkleRequest): Promise<runtime.ApiResponse<MerkleStateInfoDTO>>;
    /**
     * Gets the namespace merkle for a given namespace identifier.
     * Get namespace merkle information
     */
    getNamespaceMerkle(namespaceId: string): Promise<MerkleStateInfoDTO>;
    /**
     * Returns friendly names for namespaces.
     * Get readable names for a set of namespaces
     */
    getNamespacesNamesRaw(requestParameters: GetNamespacesNamesRequest): Promise<runtime.ApiResponse<Array<NamespaceNameDTO>>>;
    /**
     * Returns friendly names for namespaces.
     * Get readable names for a set of namespaces
     */
    getNamespacesNames(namespaceIds: NamespaceIds): Promise<Array<NamespaceNameDTO>>;
    /**
     * Gets an array of namespaces.
     * Search namespaces
     */
    searchNamespacesRaw(requestParameters: SearchNamespacesRequest): Promise<runtime.ApiResponse<NamespacePage>>;
    /**
     * Gets an array of namespaces.
     * Search namespaces
     */
    searchNamespaces(ownerAddress?: string, registrationType?: NamespaceRegistrationTypeEnum, level0?: string, aliasType?: AliasTypeEnum, pageSize?: number, pageNumber?: number, offset?: string, order?: Order): Promise<NamespacePage>;
}
