"use strict";
/* tslint:disable */
/* eslint-disable */
/*
 * Copyright 2019 NEM
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Catapult REST Endpoints
 * OpenAPI Specification of catapult-rest
 *
 * The version of the OpenAPI document: 1.0.3
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RestrictionMosaicRoutesApi = void 0;
const runtime = require("../runtime");
const models_1 = require("../models");
/**
 *
 */
class RestrictionMosaicRoutesApi extends runtime.BaseAPI {
    /**
     * Returns the mosaic restrictions for a composite hash.
     * Get the mosaic restrictions
     */
    getMosaicRestrictionsRaw(requestParameters) {
        return __awaiter(this, void 0, void 0, function* () {
            if (requestParameters.compositeHash === null || requestParameters.compositeHash === undefined) {
                throw new runtime.RequiredError('compositeHash', 'Required parameter requestParameters.compositeHash was null or undefined when calling getMosaicRestrictions.');
            }
            const queryParameters = {};
            const headerParameters = {};
            const response = yield this.request({
                path: `/restrictions/mosaic/{compositeHash}`.replace(`{${"compositeHash"}}`, encodeURIComponent(String(requestParameters.compositeHash))),
                method: 'GET',
                headers: headerParameters,
                query: queryParameters,
            });
            return new runtime.JSONApiResponse(response, (jsonValue) => models_1.MosaicRestrictionDTOFromJSON(jsonValue));
        });
    }
    /**
     * Returns the mosaic restrictions for a composite hash.
     * Get the mosaic restrictions
     */
    getMosaicRestrictions(compositeHash) {
        return __awaiter(this, void 0, void 0, function* () {
            const response = yield this.getMosaicRestrictionsRaw({ compositeHash: compositeHash });
            return yield response.value();
        });
    }
    /**
     * Returns the mosaic restrictions merkle for a given composite hash.
     * Get the mosaic restrictions merkle
     */
    getMosaicRestrictionsMerkleRaw(requestParameters) {
        return __awaiter(this, void 0, void 0, function* () {
            if (requestParameters.compositeHash === null || requestParameters.compositeHash === undefined) {
                throw new runtime.RequiredError('compositeHash', 'Required parameter requestParameters.compositeHash was null or undefined when calling getMosaicRestrictionsMerkle.');
            }
            const queryParameters = {};
            const headerParameters = {};
            const response = yield this.request({
                path: `/restrictions/mosaic/{compositeHash}/merkle`.replace(`{${"compositeHash"}}`, encodeURIComponent(String(requestParameters.compositeHash))),
                method: 'GET',
                headers: headerParameters,
                query: queryParameters,
            });
            return new runtime.JSONApiResponse(response, (jsonValue) => models_1.MerkleStateInfoDTOFromJSON(jsonValue));
        });
    }
    /**
     * Returns the mosaic restrictions merkle for a given composite hash.
     * Get the mosaic restrictions merkle
     */
    getMosaicRestrictionsMerkle(compositeHash) {
        return __awaiter(this, void 0, void 0, function* () {
            const response = yield this.getMosaicRestrictionsMerkleRaw({ compositeHash: compositeHash });
            return yield response.value();
        });
    }
    /**
     * Returns an array of mosaic restrictions.
     * Search mosaic restrictions
     */
    searchMosaicRestrictionsRaw(requestParameters) {
        return __awaiter(this, void 0, void 0, function* () {
            const queryParameters = {};
            if (requestParameters.mosaicId !== undefined) {
                queryParameters['mosaicId'] = requestParameters.mosaicId;
            }
            if (requestParameters.entryType !== undefined) {
                queryParameters['entryType'] = requestParameters.entryType;
            }
            if (requestParameters.targetAddress !== undefined) {
                queryParameters['targetAddress'] = requestParameters.targetAddress;
            }
            if (requestParameters.pageSize !== undefined) {
                queryParameters['pageSize'] = requestParameters.pageSize;
            }
            if (requestParameters.pageNumber !== undefined) {
                queryParameters['pageNumber'] = requestParameters.pageNumber;
            }
            if (requestParameters.offset !== undefined) {
                queryParameters['offset'] = requestParameters.offset;
            }
            if (requestParameters.order !== undefined) {
                queryParameters['order'] = requestParameters.order;
            }
            const headerParameters = {};
            const response = yield this.request({
                path: `/restrictions/mosaic`,
                method: 'GET',
                headers: headerParameters,
                query: queryParameters,
            });
            return new runtime.JSONApiResponse(response, (jsonValue) => models_1.MosaicRestrictionsPageFromJSON(jsonValue));
        });
    }
    /**
     * Returns an array of mosaic restrictions.
     * Search mosaic restrictions
     */
    searchMosaicRestrictions(mosaicId, entryType, targetAddress, pageSize, pageNumber, offset, order) {
        return __awaiter(this, void 0, void 0, function* () {
            const response = yield this.searchMosaicRestrictionsRaw({ mosaicId: mosaicId, entryType: entryType, targetAddress: targetAddress, pageSize: pageSize, pageNumber: pageNumber, offset: offset, order: order });
            return yield response.value();
        });
    }
}
exports.RestrictionMosaicRoutesApi = RestrictionMosaicRoutesApi;
