/**
 * Catapult REST Endpoints
 * OpenAPI Specification of catapult-rest
 *
 * The version of the OpenAPI document: 1.0.3
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import * as runtime from '../runtime';
import { MerkleStateInfoDTO, Order, SecretLockInfoDTO, SecretLockPage } from '../models';
export interface GetSecretLockRequest {
    compositeHash: string;
}
export interface GetSecretLockMerkleRequest {
    compositeHash: string;
}
export interface SearchSecretLockRequest {
    address?: string;
    secret?: string;
    pageSize?: number;
    pageNumber?: number;
    offset?: string;
    order?: Order;
}
/**
 *
 */
export declare class SecretLockRoutesApi extends runtime.BaseAPI {
    /**
     * Gets the hash lock for a given composite hash.
     * Get secret lock information
     */
    getSecretLockRaw(requestParameters: GetSecretLockRequest): Promise<runtime.ApiResponse<SecretLockInfoDTO>>;
    /**
     * Gets the hash lock for a given composite hash.
     * Get secret lock information
     */
    getSecretLock(compositeHash: string): Promise<SecretLockInfoDTO>;
    /**
     * Gets the hash lock merkle for a given composite hash.
     * Get secret lock merkle information
     */
    getSecretLockMerkleRaw(requestParameters: GetSecretLockMerkleRequest): Promise<runtime.ApiResponse<MerkleStateInfoDTO>>;
    /**
     * Gets the hash lock merkle for a given composite hash.
     * Get secret lock merkle information
     */
    getSecretLockMerkle(compositeHash: string): Promise<MerkleStateInfoDTO>;
    /**
     * Returns an array of secret locks.
     * Search secret lock entries
     */
    searchSecretLockRaw(requestParameters: SearchSecretLockRequest): Promise<runtime.ApiResponse<SecretLockPage>>;
    /**
     * Returns an array of secret locks.
     * Search secret lock entries
     */
    searchSecretLock(address?: string, secret?: string, pageSize?: number, pageNumber?: number, offset?: string, order?: Order): Promise<SecretLockPage>;
}
