/**
 * Catapult REST Endpoints
 * OpenAPI Specification of catapult-rest
 *
 * The version of the OpenAPI document: 1.0.3
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { LinkActionEnum, NetworkTypeEnum } from './';
/**
 * Transaction to delegate the account importance score to a proxy account.
 * Required for all accounts willing to activate delegated harvesting.
 * @export
 * @interface AccountKeyLinkTransactionDTO
 */
export interface AccountKeyLinkTransactionDTO {
    /**
     * A number that allows uint 32 values.
     * @type {number}
     * @memberof AccountKeyLinkTransactionDTO
     */
    size: number;
    /**
     * Entity's signature generated by the signer.
     * @type {string}
     * @memberof AccountKeyLinkTransactionDTO
     */
    signature: string;
    /**
     * Public key.
     * @type {string}
     * @memberof AccountKeyLinkTransactionDTO
     */
    signerPublicKey: string;
    /**
     * Entity version.
     * @type {number}
     * @memberof AccountKeyLinkTransactionDTO
     */
    version: number;
    /**
     *
     * @type {NetworkTypeEnum}
     * @memberof AccountKeyLinkTransactionDTO
     */
    network: NetworkTypeEnum;
    /**
     *
     * @type {number}
     * @memberof AccountKeyLinkTransactionDTO
     */
    type: number;
    /**
     * Absolute amount. An amount of 123456789 (absolute) for a mosaic with divisibility 6 means 123.456789 (relative).
     * @type {string}
     * @memberof AccountKeyLinkTransactionDTO
     */
    maxFee: string;
    /**
     * Duration expressed in number of blocks.
     * @type {string}
     * @memberof AccountKeyLinkTransactionDTO
     */
    deadline: string;
    /**
     * Public key.
     * @type {string}
     * @memberof AccountKeyLinkTransactionDTO
     */
    linkedPublicKey: string;
    /**
     *
     * @type {LinkActionEnum}
     * @memberof AccountKeyLinkTransactionDTO
     */
    linkAction: LinkActionEnum;
}
export declare function AccountKeyLinkTransactionDTOFromJSON(json: any): AccountKeyLinkTransactionDTO;
export declare function AccountKeyLinkTransactionDTOFromJSONTyped(json: any, ignoreDiscriminator: boolean): AccountKeyLinkTransactionDTO;
export declare function AccountKeyLinkTransactionDTOToJSON(value?: AccountKeyLinkTransactionDTO | null): any;
