/**
 * Catapult REST Endpoints
 * OpenAPI Specification of catapult-rest
 *
 * The version of the OpenAPI document: 1.0.3
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { NetworkTypeEnum } from './';
/**
 * Transaction to create or modify a multisig account.
 * @export
 * @interface MultisigAccountModificationTransactionDTO
 */
export interface MultisigAccountModificationTransactionDTO {
    /**
     * A number that allows uint 32 values.
     * @type {number}
     * @memberof MultisigAccountModificationTransactionDTO
     */
    size: number;
    /**
     * Entity's signature generated by the signer.
     * @type {string}
     * @memberof MultisigAccountModificationTransactionDTO
     */
    signature: string;
    /**
     * Public key.
     * @type {string}
     * @memberof MultisigAccountModificationTransactionDTO
     */
    signerPublicKey: string;
    /**
     * Entity version.
     * @type {number}
     * @memberof MultisigAccountModificationTransactionDTO
     */
    version: number;
    /**
     *
     * @type {NetworkTypeEnum}
     * @memberof MultisigAccountModificationTransactionDTO
     */
    network: NetworkTypeEnum;
    /**
     *
     * @type {number}
     * @memberof MultisigAccountModificationTransactionDTO
     */
    type: number;
    /**
     * Absolute amount. An amount of 123456789 (absolute) for a mosaic with divisibility 6 means 123.456789 (relative).
     * @type {string}
     * @memberof MultisigAccountModificationTransactionDTO
     */
    maxFee: string;
    /**
     * Duration expressed in number of blocks.
     * @type {string}
     * @memberof MultisigAccountModificationTransactionDTO
     */
    deadline: string;
    /**
     * Number of signatures needed to remove a cosignatory.
     * If we are modifying an existing multisig account, this indicates the relative change of the minimum cosignatories.
     * @type {number}
     * @memberof MultisigAccountModificationTransactionDTO
     */
    minRemovalDelta: number;
    /**
     * Number of signatures needed to approve a transaction.
     * If we are modifying an existing multisig account, this indicates the relative change of the minimum cosignatories.
     * @type {number}
     * @memberof MultisigAccountModificationTransactionDTO
     */
    minApprovalDelta: number;
    /**
     * Array of cosignatory accounts to add.
     * @type {Array<string>}
     * @memberof MultisigAccountModificationTransactionDTO
     */
    addressAdditions: Array<string>;
    /**
     * Array of cosignatory accounts to delete.
     * @type {Array<string>}
     * @memberof MultisigAccountModificationTransactionDTO
     */
    addressDeletions: Array<string>;
}
export declare function MultisigAccountModificationTransactionDTOFromJSON(json: any): MultisigAccountModificationTransactionDTO;
export declare function MultisigAccountModificationTransactionDTOFromJSONTyped(json: any, ignoreDiscriminator: boolean): MultisigAccountModificationTransactionDTO;
export declare function MultisigAccountModificationTransactionDTOToJSON(value?: MultisigAccountModificationTransactionDTO | null): any;
