/**
 * Catapult REST Endpoints
 * OpenAPI Specification of catapult-rest
 *
 * The version of the OpenAPI document: 1.0.3
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { LinkActionEnum, NetworkTypeEnum } from './';
/**
 * Transaction to link a public key to an account.
 * TLS uses the linked public key to create sessions.
 * Required for node operators.
 * @export
 * @interface NodeKeyLinkTransactionDTO
 */
export interface NodeKeyLinkTransactionDTO {
    /**
     * A number that allows uint 32 values.
     * @type {number}
     * @memberof NodeKeyLinkTransactionDTO
     */
    size: number;
    /**
     * Entity's signature generated by the signer.
     * @type {string}
     * @memberof NodeKeyLinkTransactionDTO
     */
    signature: string;
    /**
     * Public key.
     * @type {string}
     * @memberof NodeKeyLinkTransactionDTO
     */
    signerPublicKey: string;
    /**
     * Entity version.
     * @type {number}
     * @memberof NodeKeyLinkTransactionDTO
     */
    version: number;
    /**
     *
     * @type {NetworkTypeEnum}
     * @memberof NodeKeyLinkTransactionDTO
     */
    network: NetworkTypeEnum;
    /**
     *
     * @type {number}
     * @memberof NodeKeyLinkTransactionDTO
     */
    type: number;
    /**
     * Absolute amount. An amount of 123456789 (absolute) for a mosaic with divisibility 6 means 123.456789 (relative).
     * @type {string}
     * @memberof NodeKeyLinkTransactionDTO
     */
    maxFee: string;
    /**
     * Duration expressed in number of blocks.
     * @type {string}
     * @memberof NodeKeyLinkTransactionDTO
     */
    deadline: string;
    /**
     * Public key.
     * @type {string}
     * @memberof NodeKeyLinkTransactionDTO
     */
    linkedPublicKey: string;
    /**
     *
     * @type {LinkActionEnum}
     * @memberof NodeKeyLinkTransactionDTO
     */
    linkAction: LinkActionEnum;
}
export declare function NodeKeyLinkTransactionDTOFromJSON(json: any): NodeKeyLinkTransactionDTO;
export declare function NodeKeyLinkTransactionDTOFromJSONTyped(json: any, ignoreDiscriminator: boolean): NodeKeyLinkTransactionDTO;
export declare function NodeKeyLinkTransactionDTOToJSON(value?: NodeKeyLinkTransactionDTO | null): any;
